*********************************************************************************
*   -  ConvertText
*********************************************************************************	
* ()  ,  "", -
*  2007 
*********************************************************************************	
*  :
*	oCnvt = createobject('ConvertText' [, lLang])
*
*		  lLang ( ) ,  
*		   ,   :
*			lLang = .f. ( ) -  
*			lLang = .t. ( ) -  
*
*********************************************************************************	
DEFINE CLASS ConvertText as Custom 

HIDDEN aSymbols[256]		&&     
HIDDEN cTitle				&&   
cTitle = ''

PROCEDURE init
	LPARAMETERS tlLang 		&& tlLang = .t. - ;  - 
	LOCAL llReturn
	IF VARTYPE(tlLang) = 'L'
		this.aSymbols[1] = 0
		this.aSymbols[2] = 0
		this.aSymbols[3] = 0
		this.aSymbols[4] = 0
		this.aSymbols[5] = 0
		this.aSymbols[6] = 0
		this.aSymbols[7] = 0
		this.aSymbols[8] = 0
		this.aSymbols[9] = 32
		this.aSymbols[10] = 0
		this.aSymbols[11] = 0
		this.aSymbols[12] = 0
		this.aSymbols[13] = 13
		this.aSymbols[14] = 0
		this.aSymbols[15] = 0
		this.aSymbols[16] = 0
		this.aSymbols[17] = 0
		this.aSymbols[18] = 0
		this.aSymbols[19] = 0
		this.aSymbols[20] = 0
		this.aSymbols[21] = 0
		this.aSymbols[22] = 0
		this.aSymbols[23] = 0
		this.aSymbols[24] = 0
		this.aSymbols[25] = 0
		this.aSymbols[26] = 0
		this.aSymbols[27] = 0
		this.aSymbols[28] = 0
		this.aSymbols[29] = 0
		this.aSymbols[30] = 0
		this.aSymbols[31] = 0
		this.aSymbols[32] = 32
		this.aSymbols[33] = 33
		this.aSymbols[34] = 34
		this.aSymbols[35] = 35
		this.aSymbols[36] = 36
		this.aSymbols[37] = 37
		this.aSymbols[38] = 38
		this.aSymbols[39] = 39
		this.aSymbols[40] = 40
		this.aSymbols[41] = 41
		this.aSymbols[42] = 42
		this.aSymbols[43] = 43
		this.aSymbols[44] = 44
		this.aSymbols[45] = 45
		this.aSymbols[46] = 46
		this.aSymbols[47] = 47
		this.aSymbols[48] = 48
		this.aSymbols[49] = 49
		this.aSymbols[50] = 50
		this.aSymbols[51] = 51
		this.aSymbols[52] = 52
		this.aSymbols[53] = 53
		this.aSymbols[54] = 54
		this.aSymbols[55] = 55
		this.aSymbols[56] = 56
		this.aSymbols[57] = 57
		this.aSymbols[58] = 58
		this.aSymbols[59] = 59
		this.aSymbols[60] = 60
		this.aSymbols[61] = 61
		this.aSymbols[62] = 62
		this.aSymbols[63] = 63
		this.aSymbols[64] = 64
		this.aSymbols[65] = IIF(tlLang, 65, 192)
		this.aSymbols[66] = IIF(tlLang, 66, 194)
		this.aSymbols[67] = IIF(tlLang, 67, 209)
		this.aSymbols[68] = 68
		this.aSymbols[69] = IIF(tlLang, 69, 197)
		this.aSymbols[70] = 70
		this.aSymbols[71] = 71
		this.aSymbols[72] = IIF(tlLang, 72, 205)
		this.aSymbols[73] = 73
		this.aSymbols[74] = 74
		this.aSymbols[75] = IIF(tlLang, 75, 202)
		this.aSymbols[76] = 76
		this.aSymbols[77] = IIF(tlLang, 77, 204)
		this.aSymbols[78] = 78
		this.aSymbols[79] = IIF(tlLang, 79, 206)
		this.aSymbols[80] = IIF(tlLang, 80, 208)
		this.aSymbols[81] = 81
		this.aSymbols[82] = 82
		this.aSymbols[83] = 83
		this.aSymbols[84] = IIF(tlLang, 84, 210)
		this.aSymbols[85] = 85
		this.aSymbols[86] = 86
		this.aSymbols[87] = 87
		this.aSymbols[88] = IIF(tlLang, 88, 213)
		this.aSymbols[89] = 89
		this.aSymbols[90] = 90
		this.aSymbols[91] = 91
		this.aSymbols[92] = 92
		this.aSymbols[93] = 93
		this.aSymbols[94] = 94
		this.aSymbols[95] = 95
		this.aSymbols[96] = 96
		this.aSymbols[97] = IIF(tlLang, 97, 224)
		this.aSymbols[98] = 98
		this.aSymbols[99] = IIF(tlLang, 99, 241)
		this.aSymbols[100] = 100
		this.aSymbols[101] = IIF(tlLang, 101, 229)
		this.aSymbols[102] = 102
		this.aSymbols[103] = 103
		this.aSymbols[104] = 104
		this.aSymbols[105] = 105
		this.aSymbols[106] = 106
		this.aSymbols[107] = 107
		this.aSymbols[108] = 108
		this.aSymbols[109] = 109
		this.aSymbols[110] = 110
		this.aSymbols[111] = IIF(tlLang, 111, 238)
		this.aSymbols[112] = IIF(tlLang, 112, 240)
		this.aSymbols[113] = 113
		this.aSymbols[114] = 114
		this.aSymbols[115] = 115
		this.aSymbols[116] = 116
		this.aSymbols[117] = 117
		this.aSymbols[118] = 118
		this.aSymbols[119] = 119
		this.aSymbols[120] = IIF(tlLang, 120, 245)
		this.aSymbols[121] = IIF(tlLang, 121, 243)
		this.aSymbols[122] = 122
		this.aSymbols[123] = 123
		this.aSymbols[124] = 124
		this.aSymbols[125] = 125
		this.aSymbols[126] = 126
		this.aSymbols[127] = 0
		this.aSymbols[128] = IIF(tlLang, 128, 218)
		this.aSymbols[129] = IIF(tlLang, 129, 195)
		this.aSymbols[130] = 44
		this.aSymbols[131] = IIF(tlLang, 131, 227)
		this.aSymbols[132] = 34
		this.aSymbols[133] = 133
		this.aSymbols[134] = 0
		this.aSymbols[135] = 0
		this.aSymbols[136] = 136
		this.aSymbols[137] = 137
		this.aSymbols[138] = 0
		this.aSymbols[139] = 60
		this.aSymbols[140] = 0
		this.aSymbols[141] = IIF(tlLang, 75, 202)
		this.aSymbols[142] = 0
		this.aSymbols[143] = IIF(tlLang, 143, 214)
		this.aSymbols[144] = 0
		this.aSymbols[145] = 39
		this.aSymbols[146] = 39
		this.aSymbols[147] = 34
		this.aSymbols[148] = 34
		this.aSymbols[149] = 149
		this.aSymbols[150] = 45
		this.aSymbols[151] = 45
		this.aSymbols[152] = 0
		this.aSymbols[153] = 0
		this.aSymbols[154] = 0
		this.aSymbols[155] = 62
		this.aSymbols[156] = 0
		this.aSymbols[157] = IIF(tlLang, 157, 234)
		this.aSymbols[158] = 104
		this.aSymbols[159] = IIF(tlLang, 159, 246)
		this.aSymbols[160] = 0
		this.aSymbols[161] = 243
		this.aSymbols[162] = 243
		this.aSymbols[163] = 74
		this.aSymbols[164] = 164
		this.aSymbols[165] = IIF(tlLang, 165, 195)
		this.aSymbols[166] = 166
		this.aSymbols[167] = 167
		this.aSymbols[168] = 168
		this.aSymbols[169] = 169
		this.aSymbols[170] = 136
		this.aSymbols[171] = 34
		this.aSymbols[172] = 45
		this.aSymbols[173] = 45
		this.aSymbols[174] = 174
		this.aSymbols[175] = 73
		this.aSymbols[176] = 176
		this.aSymbols[177] = 177
		this.aSymbols[178] = 73
		this.aSymbols[179] = 105
		this.aSymbols[180] = IIF(tlLang, 165, 195)
		this.aSymbols[181] = 181
		this.aSymbols[182] = IIF(tlLang, 113, 0)
		this.aSymbols[183] = 149
		this.aSymbols[184] = 184
		this.aSymbols[185] = 185
		this.aSymbols[186] = 186
		this.aSymbols[187] = 34
		this.aSymbols[188] = 74
		this.aSymbols[189] = 83
		this.aSymbols[190] = 115
		this.aSymbols[191] = 105
		this.aSymbols[192] = IIF(tlLang, 65, 192)
		this.aSymbols[193] = 193
		this.aSymbols[194] = IIF(tlLang, 66, 194)
		this.aSymbols[195] = 195
		this.aSymbols[196] = 196
		this.aSymbols[197] = IIF(tlLang, 69, 197)
		this.aSymbols[198] = 198
		this.aSymbols[199] = 199
		this.aSymbols[200] = 200
		this.aSymbols[201] = 201
		this.aSymbols[202] = IIF(tlLang, 75, 202)
		this.aSymbols[203] = 203
		this.aSymbols[204] = IIF(tlLang, 77, 204)
		this.aSymbols[205] = IIF(tlLang, 72, 205)
		this.aSymbols[206] = IIF(tlLang, 79, 206)
		this.aSymbols[207] = 207
		this.aSymbols[208] = IIF(tlLang, 80,208)
		this.aSymbols[209] = IIF(tlLang, 67, 209)
		this.aSymbols[210] = IIF(tlLang, 84, 210)
		this.aSymbols[211] = 211
		this.aSymbols[212] = 212
		this.aSymbols[213] = IIF(tlLang, 88, 213)
		this.aSymbols[214] = 214
		this.aSymbols[215] = 215
		this.aSymbols[216] = 216
		this.aSymbols[217] = 217
		this.aSymbols[218] = 218
		this.aSymbols[219] = 219
		this.aSymbols[220] = 220
		this.aSymbols[221] = 221
		this.aSymbols[222] = 222
		this.aSymbols[223] = 223
		this.aSymbols[224] = IIF(tlLang, 97, 224)
		this.aSymbols[225] = 225
		this.aSymbols[226] = 226
		this.aSymbols[227] = 227
		this.aSymbols[228] = 228
		this.aSymbols[229] = IIF(tlLang, 101, 229)
		this.aSymbols[230] = 230
		this.aSymbols[231] = 231
		this.aSymbols[232] = 232
		this.aSymbols[233] = 233
		this.aSymbols[234] = 234
		this.aSymbols[235] = 235
		this.aSymbols[236] = 236
		this.aSymbols[237] = 237
		this.aSymbols[238] = IIF(tlLang, 111, 238)
		this.aSymbols[239] = 239
		this.aSymbols[240] = IIF(tlLang, 112, 240)
		this.aSymbols[241] = IIF(tlLang, 99, 241)
		this.aSymbols[242] = 242
		this.aSymbols[243] = IIF(tlLang, 121, 243)
		this.aSymbols[244] = 244
		this.aSymbols[245] = IIF(tlLang, 120, 245)
		this.aSymbols[246] = 246
		this.aSymbols[247] = 247
		this.aSymbols[248] = 248
		this.aSymbols[249] = 249
		this.aSymbols[250] = 250
		this.aSymbols[251] = 251
		this.aSymbols[252] = 252
		this.aSymbols[253] = 253
		this.aSymbols[254] = 254
		this.aSymbols[255] = 255
		this.aSymbols[256] = 256
		llReturn = .t.
	ENDIF 	
	RETURN llReturn
ENDPROC 

**************************************************************************************************
*  Convert(tcText)
*      tcText   ""   
* (  )
*     
*     "-",       
*    ,         
*  
*   ""  
*+
FUNCTION Convert(tcText)
	LOCAL i, lcText, lnLen, lnSymb, lcSymb, lcPreSymb, lnCount, lnDeletedRows, lcOut, CRLF, laText[1]
	this.cTitle = ''
	IF VARTYPE(tcText) != 'C'
		RETURN ''
	ENDIF 	
	lnLen = LEN(tcText)
	IF lnLen = 0
		RETURN '' 
	ENDIF 
	CRLF = CHR(13) + CHR(10)
*+
*    :      "" * ),
*      
*+
	lcText = ""
	lcPreSymb = ""
	FOR i = 1 TO lnLen
		lnSymb = ASC(SUBSTR(tcText, i, 1))
		IF lnSymb > 0
			lnSymb = this.aSymbols[lnSymb]				&&     
			IF lnSymb > 0								&&     -  ,
				lcSymb = CHR(lnSymb)					&&     ASCII 
				IF lcSymb = " " AND lcPreSymb = " "		&&    - ,   -  
					LOOP 								&&     
				ENDIF 
				lcText = lcText + lcSymb				&&     
				lcPreSymb = lcSymb						&&     ""
			ENDIF 
		ENDIF 	
	ENDFOR 
*+
*  :    ,      
* ,   ""  
*+
	lnCount = ALINES(laText, lcText)
	lnDeletedRows = 0
	FOR i = lnCount TO 1 STEP -1						&&    ""  ADEL()
		IF EMPTY(laText[i])
			= ADEL(laText, i)
			lnDeletedRows = lnDeletedRows + 1			&&    
		ENDIF 
	ENDFOR 
	lnCount = lnCount - lnDeletedRows
	lcOut = ""
	IF lnCount > 0
		i = 0
		DO WHILE .t.
			i = i + 1
			IF i > lnCount
				EXIT 
			ENDIF 	
			lcText = this.FormattingText(ALLTRIM(laText[i]))
			lnLen = LEN(lcText)
			IF lnLen > 0
*+
*      -  ( ),  ,    .
*+		
				IF RIGHT(lcText,1) = '-'					&&     -   ( )?
					IF i < lnCount 
						lcSymb = LEFT(laText[i+1],1)		&&     
						IF ISALPHA(lcSymb)					&&    - 
							IF ISLOWER(lcSymb)				&&    ,  "" 
								lcOut = lcOut+ LEFT(lcText, lnLen - 1)
							ELSE 							&&  -   (. -)      
								lcOut = lcOut + lcText
							ENDIF 	
							LOOP 
						ELSE 
							lcOut = lcOut + CRLF + lcText
						ENDIF 
					ENDIF 
				ELSE 
					lcOut = lcOut + lcText
				ENDIF 
				IF i < lnCount
					lcOut = lcOut + CRLF
				ENDIF 
			ENDIF 
		ENDDO 
		i = AT(CHR(13), lcOut)								&&    ( )
		IF i > 0
			this.cTitle = LEFT(lcOut, i-1)
		ENDIF 	
	ENDIF 
	RETURN lcOut
ENDFUNC 

**************************************************************************************************
*   FormattingText
*   
*+
HIDDEN FUNCTION FormattingText(tcText)
	LOCAL i, lnLen, lcText, lcSymb, lcPreSymb, lnCount
	lcText = ""
	lcPreSymb = ""
	lnLen = LEN(tcText)
	lnCount = 0
	FOR i = 1 TO lnLen
		lcSymb = SUBSTR(tcText, i, 1)
		DO CASE 
			CASE lcSymb = "-"
				IF INLIST(lcPreSymb, "!", "?", '"', ".", ",", ";", ":")
					lcSymb = " -"
				ENDIF 	
				lcText = lcText + lcSymb				&&   ()   
				lcPreSymb = '-'							&&    
				lnCount = lnCount + LEN(lcSymb)
				LOOP 
*+
*    - ,    
*+
			CASE ISALPHA(lcSymb) AND lcPreSymb = "-"
				IF i > 2								&&        ,
					IF lnCount > 1 AND SUBSTR(lcText, lnCount-1, 1) = " "							&&     ,
						lcSymb = " " + lcSymb			&&       (" -"  " - ")
					ENDIF 
				ELSE 
					IF i = 2							&&    -    , 
						lcSymb = " " + lcSymb			&&       
					ENDIF 
				ENDIF 	
*+
*    -  ,        INLIST ,
*      .
*+
			CASE ISALPHA(lcSymb) AND ISUPPER(lcSymb) AND INLIST(lcPreSymb, "!", "?", ".", ",", ";", ":", ">")
				lcSymb = " " + lcSymb
		ENDCASE 
		lcText = lcText + lcSymb
		lnCount = lnCount + LEN(lcSymb)
		lcPreSymb = RIGHT(lcSymb,1)						&&    
	ENDFOR  
	RETURN lcText
ENDFUNC 

**************************************************************************************************
*  GetTitle
*    (  ).
*       Formatting
*+
FUNCTION GetTitle()
	RETURN this.cTitle
ENDFUNC 

**************************************************************************************************
*  WordParser(lcText, @laResult, tnMinLength)
*    laResult   ,     lcText.
*      ,    ,   tnMinLength
* (   tnMinLength  3)
*+
FUNCTION WordParser(tcText, taResult, tnMinLength)
	LOCAL i, lnLen, lcSymb, lcWord, llTheSymbol, lnTextCount
	IF VARTYPE(tcText) + TYPE("taResult",1) != 'CA'
		= MESSAGEBOX("   " + CHR(13) + " WordParser  ConvertText", 16, "")
		RETURN .f.
	ENDIF 
	IF  VARTYPE(tnMinLength) != "N"
		tnMinLength = 3
	ENDIF 	
	IF tnMinLength < 0
		= MESSAGEBOX("   WordParser  ConvertText " + CHR(13) + ;
					 "   !", 16, "")
		RETURN .f.
	ENDIF 
	lnTextCount = 1
	lcWord = ""
	lnLen = LEN(tcText)
	FOR i = 1 TO lnLen
		lcSymb = SUBSTR(tcText, i, 1)
		IF ISALPHA(lcSymb) OR ISDIGIT(lcSymb)
			lcWord = lcWord + lcSymb
			llTheSymbol = .t.
		ELSE 
			IF llTheSymbol
				IF LEN(lcWord) >= tnMinLength
					DIMENSION taResult[lnTextCount]
					taResult[lnTextCount] = LOWER(ALLTRIM(lcWord))
					lnTextCount = lnTextCount + 1
				ENDIF 	
				llTheSymbol = .f.
				lcWord = ""
			ENDIF 	
		ENDIF 
	ENDFOR 
	lcWord = LOWER(ALLTRIM(lcWord))
	IF LEN(lcWord) > 0
		DIMENSION taResult[lnTextCount]
		taResult[lnTextCount] = lcWord
	ENDIF 
	RETURN .t.
ENDFUNC 

**************************************************************************************************
*  WordForms(lcWord, @laResult)
*   ()   ,   lcWord,
*   .     laResult
*+
FUNCTION WordForms
	PARAMETERS tcWords, taResult
	LOCAL i, lnWordCount, lnIndex, lcWord, lnExtCount, lcBase
	EXTERNAL ARRAY taResult
	IF VARTYPE(tcWords) + TYPE("taResult",1) != "CA"
		= MESSAGEBOX("    " + CHR(13) + " WordForms  ConvertText", 16, "")
		RETURN .f.
	ENDIF 
	tcWords = LOWER(STRTRAN(tcWords, '+', ' + '))
	pnResultCount = 1
	lnWordCount = GETWORDCOUNT(tcWords, ' ')
	lnIndex = 1
	FOR i = 1 TO lnWordCount
		lcWord = GETWORDNUM(tcWords, i, ' ')
		DIMENSION paWord[lnIndex, 2]
		lnExtCount = GETWORDCOUNT(lcWord, '|')
		IF lnExtCount = 1				&&     ( )
			paWord[lnIndex, 1] = lcWord	
			paWord[lnIndex, 2] = i
			lnIndex = lnIndex + 1
		ELSE 							&&    
			lcBase = GETWORDNUM(lcWord, 1, '|')
			IF AT("||", lcWord) > 0
				DIMENSION paWord[lnIndex, 2]
				paWord[lnIndex, 1] = lcBase
				paWord[lnIndex, 2] = i
				lnIndex = lnIndex + 1
			ENDIF 
			FOR j = 2 TO lnExtCount
				DIMENSION paWord[lnIndex, 2]
				paWord[lnIndex, 1] = lcBase + GETWORDNUM(lcWord, j, '|')
				paWord[lnIndex, 2] = i
				lnIndex = lnIndex + 1
			ENDFOR 
		ENDIF 
	ENDFOR 
	pnALen = ALEN(paWord, 1)
	this.GetNewWordForm("", 1)
	RETURN .t.
ENDFUNC 	

HIDDEN FUNCTION GetNewWordForm(tcWord, tnIndex)
	LOCAL i, llSuccess
	FOR i = 1 TO pnALen
		IF paWord[i, 2] = tnIndex
			llSuccess = .t.
			this.GetNewWordForm(tcWord + " " + ALLTRIM(paWord[i,1]), paWord[i, 2] + 1)
		ENDIF 
	ENDFOR 
	IF !llSuccess
		DIMENSION taResult[pnResultCount]
		taResult[pnResultCount] = tcWord
		pnResultCount = pnResultCount + 1
	ENDIF 
ENDFUNC 

**************************************************************************************************
*  FindWordForm(@laWords, @laText)
*    laWords    (),
*         laText.
*       ""
*+
FUNCTION FindWordForm(taWords, taText)
	LOCAL i, j, lnALenWords, lnALenText, lnCountWord, lcWord, lcNextWord, lcWord1, lcNextWord1, lnCount, llError, lnNext
	EXTERNAL ARRAY taWords, taText
	IF TYPE("taWords", 1) + TYPE("taText", 1) != "AA"
		= MESSAGEBOX(" ,  ,   !", 16, "")
		RETURN .f.
	ENDIF 	
	lnALenText = ALEN(taText, 1)									&&    
	lnALenWords = ALEN(taWords, 1)									&&   
	FOR lnCountWord = 1 TO lnALenWords								&&   taWords
*+
* ,      "+" (  "")
*+
		lnPlus = ALINES(laArray, taWords[lnCountWord], 4, '+')
		DIMENSION laSuccess[lnPlus]
		STORE .f. TO laSuccess
		DO WHILE lnPlus > 0
*+
*       
*+
			lcString = laArray[lnPlus]
			lcWord = GETWORDNUM(lcString, 1, " ")						&&     
			FOR i = 1 TO lnALenText										&&     
				lcNextWord = taText[i]
				IF this.CompareWord(lcWord, lcNextWord)					&&  ...  ,   ...
					lnCount = GETWORDCOUNT(lcString, " ")				&&     
					IF lnCount = 1										&&   -   (   ),
						laSuccess[lnPlus] = .t.
						EXIT 
					ELSE 
						llError = .f.
						FOR j = 2 TO lnCount							&&       
							lnNext = i + j - 1							&&       
							IF lnNext > lnALenText						&&     ,
								llError = .t.							&&    
								EXIT 									&&   
							ENDIF 
							lcWord1 = GETWORDNUM(lcString, j, " ") 		&&     
							lcNextWord1 = taText[lnNext]				&&   ( )   
							IF !this.CompareWord(lcWord1, lcNextWord1)	&&  "" 
								llError = .t.							&&    ,    
								EXIT 									&&   
							ENDIF 
						ENDFOR
						IF llError										&&   ,  -   
							LOOP 										&& 
						ELSE 											&&      ,
							laSuccess[lnPlus] = .t.
							EXIT 
						ENDIF 
					ENDIF 	 
				ELSE 
					LOOP 
				ENDIF 	
			ENDFOR 
			lnPlus = lnPlus - 1 
		ENDDO 
		llError = .f.
		FOR i = 1 TO ALEN(laSuccess, 1)
			IF laSuccess[i] = .f.
				llError = .t.
				EXIT 
			ENDIF 	
		ENDFOR 
		IF !llError
			RETURN .t.
		ENDIF 	
	ENDFOR 
	RETURN .f.
ENDFUNC 
			
HIDDEN FUNCTION CompareWord(tcWord, tcNextWord)
	LOCAL llAllExt, llSuccess
	IF RIGHT(tcWord, 1) = "*"					&&     (*) -     
		tcWord = LEFT(tcWord, LEN(tcWord) - 1)	&&  "" 
		llAllExt = .t.
	ELSE 
		llAllExt = .f.
	ENDIF 
	IF LEN(tcWord) <= LEN(tcNextWord)
		IF llAllExt								&&     
			IF tcNextWord = tcWord 				&&   
				llSuccess = .t.
			ENDIF 	
		ELSE 									&&    
			IF tcWord == tcNextWord				&&   
				llSuccess = .t.
			ENDIF 	
		ENDIF
	ENDIF 	 
	RETURN llSuccess
ENDFUNC 	

ENDDEFINE 